# port

A port is a connection point for attaching a single device, such as the NIC of a server, to a network. The port also describes the associated network configuration, such as the MAC and IP addresses to be used on that port.

Network v2

## port create

Create a new port

    openstack port create
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        --network <network>
        [--description <description>]
        [--device <device-id>]
        [--mac-address <mac-address>]
        [--device-owner <device-owner>]
        [--vnic-type <vnic-type>]
        [--host <host-id>]
        [--dns-domain dns-domain]
        [--dns-name <dns-name>]
        [--numa-policy-required
        |
        --numa-policy-preferred
        |
        --numa-policy-socket
        |
        --numa-policy-legacy
        ]
        [--hint <alias=value>]
        [--trusted | --not-trusted]
        [--fixed-ip
        subnet=<subnet>,ip-address=<ip-address>
        |
        --no-fixed-ip
        ]
        [--binding-profile <binding-profile>]
        [--enable
        |
        --disable
        ]
        [--enable-uplink-status-propagation
        |
        --disable-uplink-status-propagation
        ]
        [--project <project>]
        [--project-domain <project-domain>]
        [--extra-dhcp-option name=<name>[,value=<value>,ip-version={4,6}]]
        [--security-group
        <security-group>
        |
        --no-security-group
        ]
        [--qos-policy <qos-policy>]
        [--enable-port-security
        |
        --disable-port-security
        ]
        [--allowed-address ip-address=<ip-address>[,mac-address=<mac-address>]]
        [--device-profile <device-profile>]
        [--hardware-offload-type <hardware-offload-type>]
        [--tag <tag> | --no-tag]
        <name>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--network <network>

  Network this port belongs to (name or ID)

--description <description>

  Description of this port

--device <device-id>

  Port device ID

--mac-address <mac-address>

  MAC address of this port

--device-owner <device-owner>

  Device owner of this port. This is the entity that uses the port (for example, network:dhcp).

--vnic-type <vnic-type>

  VNIC type for this port (direct | direct-physical | macvtap | normal | baremetal | virtio-forwarder | vdpa | remote-managed) (default: normal)

--host <host-id>

  Allocate port on host <host-id> (ID only)

--dns-domain dns-domain

  Set DNS domain to this port (requires dns_domain extension for ports)

--dns-name <dns-name>

  Set DNS name for this port (requires DNS integration extension)

--numa-policy-required

  NUMA affinity policy required to schedule this port

--numa-policy-preferred

  NUMA affinity policy preferred to schedule this port

--numa-policy-socket

  NUMA affinity policy socket to schedule this port

--numa-policy-legacy

  NUMA affinity policy using legacy mode to schedule this port

--hint <alias=value>

  Port hints as ALIAS=VALUE or as JSON. Valid hint aliases/values: ovs-tx-steering=thread, ovs-tx-steering=hash. Valid JSON values are as specified by the Neutron API. (requires port-hints extension) (requires port-hint-ovs-tx-steering extension for alias: ovs-tx-steering) (repeat option to set multiple hints).

--trusted

  Set port to be trusted. This will be populated into the ‘binding:profile’ dictionary and passed to the services which expect it in this dictionary (for example, Nova).

--not-trusted

  Set port to be not trusted. This will be populated into the ‘binding:profile’ dictionary and passed to the services which expect it in this dictionary (for example, Nova).

--fixed-ip subnet=<subnet>,ip-address=<ip-address>

  Desired IP and/or subnet for this port (name or ID): subnet=<subnet>,ip-address=<ip-address> (repeat option to set multiple fixed IP addresses)

--no-fixed-ip

  No IP or subnet set for this port

--binding-profile <binding-profile>

  Custom data to be passed as binding:profile. Data may be passed as <key>=<value> or JSON (repeat option to set multiple binding:profile data).

--enable

  Enable port (default)

--disable

  Disable port

--enable-uplink-status-propagation

  Enable uplink status propagation (default)

--disable-uplink-status-propagation

  Disable uplink status propagation

--project <project>

  Owner’s project (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--extra-dhcp-option name=<name>[,value=<value>,ip-version={4,6}]

  Extra DHCP options to be assigned to this port: name=<name>[,value=<value>,ip-version={4,6}] (repeat option to set multiple extra DHCP options)

--security-group <security-group>

  Security group to associate with this port (name or ID) (repeat option to set multiple security groups)

--no-security-group

  Associate no security groups with this port

--qos-policy <qos-policy>

  Attach QoS policy to this port (name or ID)

--enable-port-security

  Enable port security for this port (default)

--disable-port-security

  Disable port security for this port

--allowed-address ip-address=<ip-address>[,mac-address=<mac-address>]

  Add allowed-address pair associated with this port: ip-address=<ip-address>[,mac-address=<mac-address>] (repeat option to set multiple allowed-address pairs)

--device-profile <device-profile>

  Port device profile

--hardware-offload-type <hardware-offload-type>

  Hardware offload type this port will request when attached to the network backend

--tag <tag>

  Tag to be added to the port (repeat option to set multiple tags)

--no-tag

  No tags associated with the port

name

  Name of this port

## port delete

Delete port(s)

    openstack port delete <port> [<port> ...]

port

  Port(s) to delete (name or ID)

## port list

List ports

    openstack port list
        [--format-config-file FORMAT_CONFIG]
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--device-owner <device-owner>]
        [--host <host-id>]
        [--network <network>]
        [--router
        <router>
        |
        --server <server>
        |
        --device-id <device-id>
        ]
        [--mac-address <mac-address>]
        [--long]
        [--project <project>]
        [--name <name>]
        [--security-group <security-group>]
        [--status <status>]
        [--project-domain <project-domain>]
        [--fixed-ip subnet=<subnet>,ip-address=<ip-address>,ip-substring=<ip-substring>]
        [--tags <tag>[,<tag>,...]]
        [--any-tags <tag>[,<tag>,...]]
        [--not-tags <tag>[,<tag>,...]]
        [--not-any-tags <tag>[,<tag>,...]]

--format-config-file <FORMAT_CONFIG>

  Config file for the dict-to-csv formatter

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--device-owner <device-owner>

  List only ports with the specified device owner. This is the entity that uses the port (for example, network:dhcp).

--host <host-id>

  List only ports bound to this host ID

--network <network>

  List only ports connected to this network (name or ID)

--router <router>

  List only ports attached to this router (name or ID)

--server <server>

  List only ports attached to this server (name or ID)

--device-id <device-id>

  List only ports with the specified device ID

--mac-address <mac-address>

  List only ports with the specified MAC address

--long

  List additional fields in output

--project <project>

  List only ports with the specified project (name or ID)

--name <name>

  List only ports with the specified name

--security-group <security-group>

  List only ports associated with this security group

--status <status>

  List only ports with the specified status (‘ACTIVE’, ‘BUILD’, ‘DOWN’, ‘ERROR’)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--fixed-ip subnet=<subnet>,ip-address=<ip-address>,ip-substring=<ip-substring>

  Desired IP and/or subnet for filtering ports (name or ID): subnet=<subnet>,ip-address=<ip-address>,ip-substring=<ip-substring> (repeat option to filter multiple fixed IP addresses)

--tags <tag>[,<tag>,...]

  List ports which have all given tag(s) (Comma-separated list of tags)

--any-tags <tag>[,<tag>,...]

  List ports which have any given tag(s) (Comma-separated list of tags)

--not-tags <tag>[,<tag>,...]

  Exclude ports which have all given tag(s) (Comma-separated list of tags)

--not-any-tags <tag>[,<tag>,...]

  Exclude ports which have any given tag(s) (Comma-separated list of tags)

## port set

Set port properties

    openstack port set
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--description <description>]
        [--device <device-id>]
        [--mac-address <mac-address>]
        [--device-owner <device-owner>]
        [--vnic-type <vnic-type>]
        [--host <host-id>]
        [--dns-domain dns-domain]
        [--dns-name <dns-name>]
        [--numa-policy-required
        |
        --numa-policy-preferred
        |
        --numa-policy-socket
        |
        --numa-policy-legacy
        ]
        [--hint <alias=value>]
        [--trusted | --not-trusted]
        [--enable | --disable]
        [--name <name>]
        [--fixed-ip subnet=<subnet>,ip-address=<ip-address>]
        [--no-fixed-ip]
        [--binding-profile <binding-profile>]
        [--no-binding-profile]
        [--qos-policy <qos-policy>]
        [--security-group <security-group>]
        [--no-security-group]
        [--enable-port-security
        |
        --disable-port-security
        ]
        [--allowed-address ip-address=<ip-address>[,mac-address=<mac-address>]]
        [--no-allowed-address]
        [--extra-dhcp-option name=<name>[,value=<value>,ip-version={4,6}]]
        [--data-plane-status <status>]
        [--enable-uplink-status-propagation
        |
        --disable-uplink-status-propagation
        ]
        [--tag <tag>]
        [--no-tag]
        <port>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--description <description>

  Description of this port

--device <device-id>

  Port device ID

--mac-address <mac-address>

  MAC address of this port (admin only)

--device-owner <device-owner>

  Device owner of this port. This is the entity that uses the port (for example, network:dhcp).

--vnic-type <vnic-type>

  VNIC type for this port (direct | direct-physical | macvtap | normal | baremetal | virtio-forwarder | vdpa | remote-managed) (default: normal)

--host <host-id>

  Allocate port on host <host-id> (ID only)

--dns-domain dns-domain

  Set DNS domain to this port (requires dns_domain extension for ports)

--dns-name <dns-name>

  Set DNS name for this port (requires DNS integration extension)

--numa-policy-required

  NUMA affinity policy required to schedule this port

--numa-policy-preferred

  NUMA affinity policy preferred to schedule this port

--numa-policy-socket

  NUMA affinity policy socket to schedule this port

--numa-policy-legacy

  NUMA affinity policy using legacy mode to schedule this port

--hint <alias=value>

  Port hints as ALIAS=VALUE or as JSON. Valid hint aliases/values: ovs-tx-steering=thread, ovs-tx-steering=hash. Valid JSON values are as specified by the Neutron API. (requires port-hints extension) (requires port-hint-ovs-tx-steering extension for alias: ovs-tx-steering) (repeat option to set multiple hints).

--trusted

  Set port to be trusted. This will be populated into the ‘binding:profile’ dictionary and passed to the services which expect it in this dictionary (for example, Nova).

--not-trusted

  Set port to be not trusted. This will be populated into the ‘binding:profile’ dictionary and passed to the services which expect it in this dictionary (for example, Nova).

--enable

  Enable port

--disable

  Disable port

--name <name>

  Set port name

--fixed-ip subnet=<subnet>,ip-address=<ip-address>

  Desired IP and/or subnet for this port (name or ID): subnet=<subnet>,ip-address=<ip-address> (repeat option to set multiple fixed IP addresses)

--no-fixed-ip

  Clear existing information of fixed IP addresses. Specify both –fixed-ip and –no-fixed-ip to overwrite the current fixed IP addresses.

--binding-profile <binding-profile>

  Custom data to be passed as binding:profile. Data may be passed as <key>=<value> or JSON (repeat option to set multiple binding:profile data).

--no-binding-profile

  Clear existing information of binding:profile. Specify both –binding-profile and –no-binding-profile to overwrite the current binding:profile information.

--qos-policy <qos-policy>

  Attach QoS policy to this port (name or ID)

--security-group <security-group>

  Security group to associate with this port (name or ID) (repeat option to set multiple security groups)

--no-security-group

  Clear existing security groups associated with this port

--enable-port-security

  Enable port security for this port

--disable-port-security

  Disable port security for this port

--allowed-address ip-address=<ip-address>[,mac-address=<mac-address>]

  Add allowed-address pair associated with this port: ip-address=<ip-address>[,mac-address=<mac-address>] (repeat option to set multiple allowed-address pairs)

--no-allowed-address

  Clear existing allowed-address pairs associated with this port. Specify both –allowed-address and –no-allowed-address to overwrite the current allowed-address pairs.

--extra-dhcp-option name=<name>[,value=<value>,ip-version={4,6}]

  Extra DHCP options to be assigned to this port: name=<name>[,value=<value>,ip-version={4,6}] (repeat option to set multiple extra DHCP options)

--data-plane-status <status>

  Set data plane status of this port (ACTIVE | DOWN). Unset it to None with the ‘port unset’ command (requires data plane status extension).

--enable-uplink-status-propagation

  Enable uplink status propagation

--disable-uplink-status-propagation

  Disable uplink status propagation

--tag <tag>

  Tag to be added to the port (repeat option to set multiple tags)

--no-tag

  Clear tags associated with the port. Specify both –tag and –no-tag to overwrite current tags

port

  Port to modify (name or ID)

## port show

Display port details

    openstack port show <port>

port

  Port to display (name or ID)

## port unset

Unset port properties

    openstack port unset
        [--extra-property type=<property_type>,name=<property_name>,value=<property_value>]
        [--fixed-ip subnet=<subnet>,ip-address=<ip-address>]
        [--binding-profile <binding-profile-key>]
        [--security-group <security-group>]
        [--allowed-address ip-address=<ip-address>[,mac-address=<mac-address>]]
        [--qos-policy]
        [--data-plane-status]
        [--numa-policy]
        [--host]
        [--hints]
        [--device]
        [--device-owner]
        [--tag <tag> | --all-tag]
        <port>

--extra-property type=<property_type>,name=<property_name>,value=<property_value>

  Additional parameters can be passed using this property. Default type of the extra property is string (‘str’), but other types can be used as well. Available types are: ‘dict’, ‘list’, ‘str’, ‘bool’, ‘int’. In case of ‘list’ type, ‘value’ can be semicolon-separated list of values. For ‘dict’ value is semicolon-separated list of the key:value pairs.

--fixed-ip subnet=<subnet>,ip-address=<ip-address>

  Desired IP and/or subnet which should be removed from this port (name or ID): subnet=<subnet>,ip-address=<ip-address> (repeat option to unset multiple fixed IP addresses)

--binding-profile <binding-profile-key>

  Desired key which should be removed from binding:profile (repeat option to unset multiple binding:profile keys)

--security-group <security-group>

  Security group which should be removed this port (name or ID) (repeat option to unset multiple security groups)

--allowed-address ip-address=<ip-address>[,mac-address=<mac-address>]

  Desired allowed-address pair which should be removed from this port: ip-address=<ip-address>[,mac-address=<mac-address>] (repeat option to unset multiple allowed-address pairs)

--qos-policy

  Remove the QoS policy attached to the port

--data-plane-status

  Clear existing data plane status information

--numa-policy

  Clear existing NUMA affinity policy

--host

  Clear host binding for the port

--hints

  Clear hints for the port

--device

  Clear device ID for the port.

--device-owner

  Clear device owner for the port.

--tag <tag>

  Tag to be removed from the port (repeat option to remove multiple tags)

--all-tag

  Clear all tags associated with the port

port

  Port to modify (name or ID)

this page last updated: 2026-04-01 09:44:20

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.